<template src="./template.html"></template>

<script lang="ts">
import { getModule } from "nuxt-property-decorator";
import { Vue, Component, Prop, Watch } from "vue-property-decorator";
import AdminGalleryModule from "~/store/adminGallery";
import { api } from "~/common/constaint";
import { apiErrorHandler } from "~/utils/apiHanlers";
import { cloneDeep } from "lodash";
@Component({})
export default class AdminGalleryComponent extends Vue {
  adminGallery = getModule(AdminGalleryModule, this.$store);

  @Prop({ default: false })
  isSelectMultipleImage!: boolean;

  @Prop()
  isShowUploadPhoto!: boolean;

  @Prop()
  limitImage!: boolean;

  @Prop()
  dialogMediaPicker!: boolean;

  @Prop()
  imageAdd!: string;

  @Prop()
  imageVariant!: any;

  @Prop({ default: false })
  isImageVariant!: boolean;

  @Prop()
  tiptapWord!: boolean;

  @Prop()
  imageType!: string;

  @Prop()
  imageId!: string;

  @Prop()
  listCoverIdComponent!: {
    _id: string;
    imageUrl: string;
  };

  search = "";

  gallery = {
    tagId: "",
    file: null,
  };

  dialogCreateTag = false;
  dialogRenameTag = false;
  dialogDeleteTag = false;
  dialogDeleteImage = false;

  nameTag = "";
  tagId = "";

  coverId = "";
  listCoverId: any = [];
  loading = false;

  async mounted() {
    // await this.onGetListTag();
    if (this.limitImage) {
      this.$store.commit(
        "adminGallery/setListGallery",
        this.listCoverIdComponent
      );
    } else {
      this.onGetListImgCategory();
    }
  }

  beforeDestroy() {
    this.openDialogCloseUploadImage();
  }

  async onGetListImgCategory() {
    try {
      await this.$store.dispatch("adminGallery/onGetListImgCaterogy", {
        ctx: this,
        tagId: this.tagId,
      });
    } catch (error) {}
  }
  async onGetListTag() {
    try {
      await this.$store.dispatch("adminGallery/onGetListTag", {
        ctx: this,
      });
    } catch (error) {}
  }

  async onCreateTag() {
    try {
      if (!this.nameTag) {
        return this.$pushNotification.error("Please enter tag name");
      }
      await this.$store.dispatch("adminGallery/onCreateTag", {
        ctx: this,
        name: this.nameTag,
      });
      this.dialogCreateTag = false;
    } catch (error) {}
  }

  openDialogUpdateTag(tagId: string) {
    if (tagId) {
      this.tagId = tagId;
      this.dialogRenameTag = true;
    }
  }

  async onUpdateTag() {
    try {
      if (!this.nameTag) {
        return this.$pushNotification.error("Please enter tag name");
      }
      if (!this.tagId) {
        return this.$pushNotification.error("Not found tagId");
      }
      const payload = {
        name: this.nameTag,
        tagId: this.tagId,
      };
      await this.$store.dispatch("adminGallery/onUpdateTag", {
        ctx: this,
        payload,
      });
      this.dialogRenameTag = false;
    } catch (error) {
      console.log("error :>> ", error);
    }
  }

  openDialogDeleteTag(tagId: string) {
    if (tagId) {
      this.tagId = tagId;
      this.dialogDeleteTag = true;
    }
  }

  async onDeleteTag() {
    try {
      if (!this.tagId) {
        return this.$pushNotification.error("Not found tagId");
      }
      await this.$store.dispatch("adminGallery/onDeleteTag", {
        ctx: this,
        tagId: this.tagId,
      });
      this.dialogDeleteTag = false;
      this.tagId = this.listTag[0]._id;
    } catch (error) {}
  }

  showImageChosen(gallery: any) {
    if (this.limitImage) {
      if (this.coverId === gallery._id) {
        return true;
      } else {
        return false;
      }
    } else {
      const findCoverId = this.listCoverId.find(
        (cover: any) => cover._id === gallery._id
      );
      if (findCoverId) {
        return true;
      }
      return false;
    }
  }

  async selectedImage(gallery: any) {
    if (this.limitImage) {
      this.coverId = gallery._id;
    } else {
      const findIndex = this.listCoverId.findIndex(
        (cover: any) => cover._id === gallery._id
      );
      if (findIndex === -1) {
        this.listCoverId.push({
          _id: gallery._id,
          imageUrl: gallery.imageUrl,
        });
      } else {
        this.listCoverId.splice(findIndex, 1);
      }
    }
  }

  async onHandleSelectedImage() {
    if (this.limitImage) {
      const findImageUrl = this.listGallery.find(
        (gallery: any) => gallery._id === this.coverId
      );
      if (this.isImageVariant) {
        if (!findImageUrl) return;
        const imageVariant = {
          imageId: findImageUrl._id,
          imageUrl: findImageUrl.imageUrl || "",
        };
        this.$emit("update:imageVariant", imageVariant);
        this.$emit("update:isImageVariant", false);
      } else if (this.tiptapWord) {
        this.$emit("update:imageAdd", `${api}/${findImageUrl.imageUrl}`);
        this.$emit("update:tiptapWord", false);
      } else {
        await this.$store.commit("adminCollection/setCoverId", {
          coverId: this.coverId,
          imageUrl: findImageUrl?.imageUrl || "",
        });
        // await this.$store.commit("adminCollection/setCoverId", {
        // 	coverId: this.coverId,
        // 	imageUrl: findImageUrl?.imageUrl || "",
        // });

        // this.coverId = "";
      }
    } else {
      this.$store.commit("adminGallery/setListCoverId", this.listCoverId);
      this.listCoverId = [];
    }
    this.coverId = "";

    this.$emit("update:dialogMediaPicker", false);
    this.$emit("update:isSelectMultipleImage", false);
  }

  openDialogDeleteGallery() {
    this.dialogDeleteImage = true;
  }
  openDialogDeleteGalleryMultiple() {
    this.dialogDeleteImage = true;
  }
  async onHandleDeleteGallery() {
    try {
      this.loading = true;
      const body = {
        listImageId:
          this.listCoverId.map((item: any) => item._id) || this.coverId,
      };
      await this.$api.gallery.delete(body);
      this.$pushNotification.success("Delete photo successfully");
      this.onGetListImgCategory();
      this.coverId = "";
      this.listCoverId = [];
      this.dialogDeleteImage = false;
    } catch (error) {
      apiErrorHandler(error, this);
    } finally {
      this.loading = false;
    }
  }

  resetImageUploader() {
    //@ts-ignore
    this.$refs.fileImage.$refs.input.value = "";
  }

  onSelectImage() {
    this.resetImageUploader();
    //@ts-ignore
    this.$refs.fileImage.$refs.input.click();
  }

  selecAllImage() {
    const listCoverId = this.listGallery.filter((img: any) => {
      return {
        coverId: img._id,
        imageUrl: img.imageUrl,
      };
    });
    this.listCoverId = listCoverId;
  }

  deSelectAllImage() {
    this.listCoverId = [];
  }

  onChangeImage(e: any) {
    if (e.length > 0) {
      for (let item of e) {
        if (!item.type.includes("image/")) {
          continue;
        }
      }
      this.gallery.file = e;
    }
  }

  dragover(event: any) {
    event.preventDefault();
    // Add some visual fluff to show the user can drop its files
    //   if (!event.currentTarget.classList.contains('bg-green-300')) {
    //     event.currentTarget.classList.remove('bg-gray-100');
    //     event.currentTarget.classList.add('bg-green-300');
    //   }
  }
  dragleave(event: any) {
    // Clean up
    //   event.currentTarget.classList.add('bg-gray-100');
    //   event.currentTarget.classList.remove('bg-green-300');
  }
  drop(event: any) {
    event.preventDefault();
    //@ts-ignore
    // this.$refs.fileImage.files = event.dataTransfer.files;
    if (event.dataTransfer.files.length > 0) {
      this.gallery.file = event.dataTransfer.files;
    }
  }

  openDialogCloseUploadImage() {
    this.$store.commit("adminGallery/setValueBoolane", {
      status: false,
      type: "isUploadImage",
    });
  }

  convertImage(url: string) {
    return `${api}/${url}`;
  }

  get loadingTableTag() {
    return this.$store.state["adminGallery"].loadingTableTag;
  }

  get loadingTableGallery() {
    return this.$store.state["adminGallery"].loadingTableGallery;
  }

  get loadingHandler() {
    return this.$store.state["adminGallery"].loading;
  }

  get loadingTable() {
    return this.$store.state["adminGallery"].loadingTable;
  }

  get listTag() {
    return this.$store.state["adminGallery"].listTag;
  }

  get listGallery() {
    return this.$store.state["adminGallery"].listGallery;
  }

  get isUploadImage() {
    return this.$store.state.adminGallery.isUploadImage;
  }

  get progressUploadImage() {
    return this.$store.state.adminGallery.progress;
  }
  get isGallery() {
    if (window.location.href.includes("/admin/gallery")) {
      return true;
    }
    return false;
  }
  @Watch("tagId")
  changedTagId(val: string) {
    this.$store.commit("adminGallery/setTagId", val);
    this.coverId = "";
    this.listCoverId = [];
    this.onGetListImgCategory();
  }

  @Watch("gallery.file")
  changedFileImage(val: any) {
    if (val) {
      const listImg = cloneDeep(val);
      const formData = new FormData();
      let checkAllImageIsNumber = false;
      for (const img of listImg) {
        if (!isNaN(parseInt(img.name))) {
          checkAllImageIsNumber = true;
        }
      }
      if (checkAllImageIsNumber) {
        listImg.sort((a: any, b: any) => {
          return a.name - b.name;
        });
      }
      for (const img of listImg) {
        formData.append("images", img);
      }
      formData.append("tagId", this.tagId);
      this.$store.dispatch("adminGallery/onUploadImageGallery", {
        ctx: this,
        payload: formData,
      });
    }
  }

  @Watch("dialogCreateTag")
  changedDialogCreateTag(val: boolean) {
    if (!val) {
      this.nameTag = "";
    }
  }

  @Watch("dialogRenameTag")
  changedDialogUpdateTag(val: boolean) {
    if (!val) {
      this.nameTag = "";
      // this.tagId = "";
    }
  }

  @Watch("dialogMediaPicker")
  async closeDialogMediaPicker(val: boolean) {
    this.coverId = "";
    this.listCoverId = [];
    this.$emit("update:isSelectMultipleImage", false);
    this.$store.commit("adminGallery/setListGallery", []);
    if (val) {
      if (this.limitImage) {
        this.$store.commit(
          "adminGallery/setListGallery",
          this.listCoverIdComponent
        );
      } else {
        this.onGetListImgCategory();
      }
    }
  }
}
</script>

<style src="./style.css"></style>
